(function() {
  'use strict';
  var app;

  app = angular.module('myApp', ['pascalprecht.translate', 'ngRoute', 'pandorabox.pbcat', 'pandorabox.service', 'pandorabox.widgets', 'pandorabox.filter', 'pandorabox.ubus', 'pandorabox.pages'], angular.noop);

  app.config(["$translateProvider", function($translateProvider) {
    $translateProvider.translations('cn', {
      "TITLE": "ICC Router",
      "proxy service": "代理服务",
      "Register": "立即注册-ICC Router",
      "config title": "配置",
      "proxy mode": "代理模式",
      "shadowfog_user": "用户名",
      "shadowfog_passwd": "密码",
      "DNSList SYNC Failed. Please check your network!": "DNS列表同步失败。请检查你的网络！",
      "The network is unreachable!": "无法访问网络！",
      "Request failed! Check your username or password!": "请求失败！检查您的用户名或密码！",
      "Username or Password error!": "密码或者用户名错误",
      "Data package has expired. Please recharge!": "服务租约已到期，请续约！",
      "Frequent request, retry 5 seconds later!": "请求太频繁，请5秒后重试。",
      "Abnormal account, check your account status!": "帐户异常，请检查您的帐户状态！",
      "Server internal error, try later!": "服务器错误，稍后再试！",
      "Connecting to Fog...": "连接中。。。",
      "GFW-List auto proxy": "GFW-列表自动代理",
      "Submit": "提交",
      "global proxy": "全局代理",
      "Success": "成功"
    });
    $translateProvider.preferredLanguage('cn');
  }]);

  app.controller('ShadowfogCtrl', ["$scope", "Api", "$rootScope", "$interval", "FloatDiv", "Fn", function($scope, Api, $rootScope, $interval, FloatDiv, Fn) {
    var _CONFIG, checkShadowFogStat, parentScope, proxyMode, uid;
    parentScope = window.parent.angular.element(window.frameElement).scope();
    Api.rpc._token = parentScope.Api.rpc.getToken();
    _CONFIG = 'shadowfog';
    $scope.shadowfog = {};
    $scope.proxyMode = proxyMode = {
      "GFW-List auto proxy": "M",
      "global proxy": "G"
    };
    $scope.enabled = void 0;
    Api.uci.load([_CONFIG]).then(function() {
      var _enabled, data;
      data = Api.uci.get(_CONFIG, 'test');
      if (!data) {
        return;
      }
      if (data.enabled === void 0) {
        _enabled = true;
      } else {
        _enabled = +data.enabled ? true : false;
      }
      $scope.enabled = _enabled;
      return $scope.shadowfog = data;
    });
    $scope.switchStatus = function() {
      var enabled;
      if (!$scope.shadowfog['.name']) {
        $scope.enabled = false;
        return false;
      }
      enabled = $scope.enabled ? 0 : 1;
      Api.uci.set(_CONFIG, $scope.shadowfog['.name'], 'enabled', enabled);
      Api.uci.save().then(Api.uci.apply);
      $scope.shadowfog.enabled = !!enabled;
      $scope.enabled = !!enabled;
      return true;
    };
    uid = null;
    $scope.submit = function() {
      var data, float, key, value, values;
      float = FloatDiv.once();
      data = $scope.shadowfog;
      $interval.cancel(uid);
      uid = null;
      $scope.ShadowFogStat = null;
      values = {
        shadowfog_user: data.shadowfog_user,
        shadowfog_passwd: data.shadowfog_passwd,
        proxy_mode: data.proxy_mode
      };
      for (key in values) {
        value = values[key];
        Api.uci.set(_CONFIG, data['.name'], key, value);
      }
      Api.uci.save().then(Api.uci.apply)["finally"](function() {
        return Api.aio.restart('shadowfog').then(function() {
          float();
          return uid = $interval(checkShadowFogStat, 5000, 10);
        });
      });
      return true;
    };
    (checkShadowFogStat = function() {
      var _ref;
      _ref = 'ShadowFogStat';
      Api.uci.unload(_ref);
      Api.uci.load(_ref).then(function() {
        var _rs, error;
        _rs = Api.uci.get(_ref, 'message');
        try {
          return $scope.ShadowFogStat = _rs.stat === "1" ? 'Success' : _rs.message;
        } catch (error1) {
          error = error1;
          $scope.ShadowFogStat = null;
          return console.warn("没有任何反馈信息，请检查文件是否存在。", error);
        }
      });
    })();
    $scope.$on('$destroy', function() {
      $interval.cancel(uid);
      return uid = null;
    });
  }]);

}).call(this);
