(function() {
  'use strict';
  var app;

  app = angular.module('myApp', ['pascalprecht.translate', 'ngRoute', 'pandorabox.pbcat', 'pandorabox.service', 'pandorabox.components', 'pandorabox.filter'], angular.noop);

  app.config(["$translateProvider", function($translateProvider) {
    $translateProvider.translations('cn', {
      "TITLE": "ICC Router",
      "proxy service": "代理服务",
      "Register": "立即注册-ICC Router",
      "config title": "配置",
      "proxy mode": "代理模式",
      "shadowfog_user": "用户名",
      "shadowfog_passwd": "密码",
      "DNSList SYNC Failed. Please check your network!": "DNS列表同步失败。请检查你的网络！",
      "The network is unreachable!": "无法访问网络！",
      "Request failed! Check your username or password!": "请求失败！检查您的用户名或密码！",
      "Username or Password error!": "密码或者用户名错误",
      "Data package has expired. Please recharge!": "服务租约已到期，请续约！",
      "Frequent request, retry 5 seconds later!": "请求太频繁，请5秒后重试。",
      "Abnormal account, check your account status!": "帐户异常，请检查您的帐户状态！",
      "Server internal error, try later!": "服务器错误，稍后再试！",
      "Connecting to Fog!": "成功连接到ICC Router！",
      "GFW-List auto proxy": "GFW-列表自动代理",
      "Submit": "提交",
      "global proxy": "全局代理",
      "Success": "成功"
    });
    $translateProvider.preferredLanguage('cn');
  }]);

  app.controller('ShadowfogCtrl', ["$scope", "$UCI", "$rootScope", "$interval", "FloatDiv", "Fn", function($scope, $UCI, $rootScope, $interval, FloatDiv, Fn) {
    var _CONFIG, _restart, checkShadowFogStat, delOnUCIsave, proxyMode;
    _CONFIG = 'shadowfog';
    $scope.shadowfog = {};
    $scope.proxyMode = proxyMode = {
      "GFW-List auto proxy": "M",
      "global proxy": "G"
    };
    $scope.enabled = false;
    $UCI.$sync(_CONFIG).then(function() {
      var _cfg, _enabled, data, item, key, ref, ref1;
      data = (ref = (ref1 = $UCI.$Native) != null ? ref1.shadowfog : void 0) != null ? ref : {};
      _cfg = {};
      for (key in data) {
        item = data[key];
        if (item['.type'] = 'shadowfog' && item.hasOwnProperty('shadowfog_passwd') && item.hasOwnProperty('shadowfog_user')) {
          if (item.enabled === void 0) {
            _enabled = true;
          } else {
            _enabled = +item.enabled ? true : false;
          }
          $scope.enabled = _enabled;
          _cfg = item;
          break;
        }
      }
      return $scope.shadowfog = _cfg;
    });
    $scope.switchStatus = function() {
      var enabled;
      if (!$scope.shadowfog['.name']) {
        $scope.enabled = false;
        return false;
      }
      enabled = $scope.enabled ? 1 : 0;
      $UCI.$set(_CONFIG, $scope.shadowfog['.name'], {
        enabled: enabled
      });
      $UCI.$save();
      $scope.shadowfog.enabled = enabled;
      return true;
    };
    $scope.submit = function() {
      var data, float, values;
      float = FloatDiv.once();
      data = $scope.shadowfog;
      values = {
        shadowfog_user: data.shadowfog_user,
        shadowfog_passwd: data.shadowfog_passwd,
        proxy_mode: data.proxy_mode
      };
      $UCI.$set(_CONFIG, data['.name'], values);
      $UCI.$save();
      float();
      return true;
    };
    (checkShadowFogStat = function() {
      $UCI.$command("GET cat /tmp/ShadowFogStat", 'now').then(function(data) {
        var _rs, error;
        if (data.status === 'ok') {
          _rs = data.commands[0].content.join(' ');
          try {
            _rs = JSON.parse(_rs);
            return $scope.ShadowFogStat = _rs.stat === "0" ? 'Success' : _rs.message;
          } catch (error1) {
            error = error1;
            $scope.ShadowFogStat = null;
            return console.warn("/tmp/ShadowFogStat 没有任何反馈信息，请检查文件是否存在。", error);
          }
        } else {
          $scope.ShadowFogStat = null;
          return console.warn("/tmp/ShadowFogStat 没有任何反馈信息，请检查文件是否存在。");
        }
      });
    })();
    _restart = function() {
      return $UCI.$command("GET /etc/init.d/shadowfog restart", 'now');
    };
    delOnUCIsave = $rootScope.$on('$UCI.$save', function(_, config) {
      _restart().then(function() {
        var uid;
        return uid = $interval(checkShadowFogStat, 3000, 10);
      });
    });
    $scope.$on('$destroy', function() {
      return delOnUCIsave();
    });
  }]);

}).call(this);
