#!/bin/sh


platform="$1"

ROUTER_VERSION=12
SERVER_ADDRESS='ubuntu@shadowfog.com'

#### RELEASE IPK START ####

    DIR=release/router
    #### INSTALL APP FILE START ####

        APP_DIR=$DIR/www
        mkdir -p $APP_DIR

        cp -R ../pandorabox/shadowfog-libev/files/APPS $APP_DIR/
        mv $APP_DIR/APPS $APP_DIR/apps

    #### INSTALL APP FILE END   ####


    #### INSTALL CONF FILE START ####

        CONF_DIR=$DIR/etc/config
        mkdir -p $CONF_DIR

        cp ../pandorabox/shadowfog-libev/files/shadowfog $CONF_DIR/

    #### INSTALL CONF FILE END   ####


    #### MAKE data.tar.gz START ####

        cd $DIR
        tar -cvzf data.tar.gz *
        DATA_SIZE=`wc -c data.tar.gz | cut -f1 -d' '`
        echo "#### DATA_SIZE: "$DATA_SIZE" ####"
        cd -

    #### MAKE data.tar.gz END   ####


    #### MAKE control.tar.gz START ####

        cd $DIR

        #### MAKE control file START ####

            CONTROL_FILE=control

            echo 'Package: shadowfog-libev'                                 > $CONTROL_FILE
            echo 'Version: '$ROUTER_VERSION                                >> $CONTROL_FILE
            echo 'Depends: libc, libopenssl, libpthread, libpcre, libcurl' >> $CONTROL_FILE
            echo 'Source: package/shadowfog-libev'                         >> $CONTROL_FILE
            echo 'Section: net'                                            >> $CONTROL_FILE
            echo 'Maintainer: Rabbit <86487349leslie@gmail.com>'           >> $CONTROL_FILE
            echo 'Architecture: mipsel_24kec_dsp'                          >> $CONTROL_FILE
            echo 'Installed-Size: '$DATA_SIZE                              >> $CONTROL_FILE
            echo 'Description:  Shadowsocks-libev is a lightweight secured socks5 proxy for embedded devices and low end boxes.' >> $CONTROL_FILE

        #### MAKE control file END  ####


        #### MAKE postinst file START ####

            POSTINST_FILE=postinst

            echo '#!/bin/sh'                                > $POSTINST_FILE
            echo '[ "${IPKG_NO_SCRIPT}" = "1" ] && exit 0' >> $POSTINST_FILE
            echo '. ${IPKG_INSTROOT}/lib/functions.sh'     >> $POSTINST_FILE
            echo 'default_postinst $0 $@'                  >> $POSTINST_FILE

            chmod 755 $POSTINST_FILE

        #### MAKE postinst file END   ####


        #### MAKE postinst-pkg file START ####
 
            POSTINST_PKG_FILE=postinst-pkg

            echo '#!/bin/sh'                                            > $POSTINST_PKG_FILE
            echo 'echo "conf-dir=/etc/dnsmasq.d" >> /etc/dnsmasq.conf' >> $POSTINST_PKG_FILE
            echo '/usr/bin/all_in_one &'                               >> $POSTINST_PKG_FILE

            chmod 755 $POSTINST_PKG_FILE

        #### MAKE postinst-pkg file END   ####


        #### MAKE prerm file START ####

            #PRERM_FILE=prerm

            #echo '#!/bin/sh'                            > $PRERM_FILE
            #echo '. ${IPKG_INSTROOT}/lib/functions.sh' >> $PRERM_FILE
            #echo 'default_prerm $0 $@'                 >> $PRERM_FILE
            
            #chmod 755 $PRERM_FILE

        #### MAKE prerm file END   ####


        tar -cvzf control.tar.gz $CONTROL_FILE $POSTINST_FILE $POSTINST_PKG_FILE $PRERM_FILE
   
        cd -

    #### MAKE control.tar.gz END   ####


    #### MAKE debian-binary FILE START ####
        DEBIAN_BINARY_FILE=debian-binary
        echo "$ROUTER_VERSION" > $DIR/$DEBIAN_BINARY_FILE
    #### MAKE debian-binary FILE END   ####


    IPK_NAME='shadowfog-router-'$platform'.ipk'

    cd $DIR

    tar -czvf ../$IPK_NAME control.tar.gz data.tar.gz debian-binary

    IPK_RELEASE_URL=/var/www/downloads/ipk/pandorabox/

    cd -

    scp release/$IPK_NAME ${SERVER_ADDRESS}:$IPK_RELEASE_URL


#### RELEASE IPK END   ####

