#!/bin/sh
#
# Update Package

platform="$1"
SERVER_ADDRESS='ubuntu@shadowfog.com'

#### Router Release START ####

    #### MAKE UPDATE CONF START ####

        ROUTER_VERSION=12
        UPDATE_DIR=release/update
        ROUTER_UPDATE_JSON=$UPDATE_DIR/router-update.json
        PACKAGE_NAME='SHADOWFOG_'${platform}'_ROUTER'

        mkdir -p $UPDATE_DIR
        echo  -n '{"package":"'${PACKAGE_NAME}'.json",'  > $ROUTER_UPDATE_JSON
        echo  -n '"version":"'$ROUTER_VERSION'"}'       >> $ROUTER_UPDATE_JSON

    #### MAKE UPDATE CONF END   ####


    DIR=release/router
    mkdir -p $DIR

    #### INSTALL BINARY FILE START ####

        BIN_DIR=$DIR/usr/bin
        mkdir -p $BIN_DIR
 
        cp ./shadowfog_restart/shadowfog_restart  $BIN_DIR/
        cp ./shadowfog_update/shadowfog_update    $BIN_DIR/
        cp ./src/ss-list2dns            $BIN_DIR/
        cp ./src/ss-router              $BIN_DIR/
        cp ./src/ss-tunnel              $BIN_DIR/
        cp ./src/ss-redir               $BIN_DIR/

        ####  INSTALL auto-restart FILE 
        cp ../pandorabox/shadowfog-libev/files/all_in_one $BIN_DIR/

    #### INSTALL BINARY FILE END   ####


    #### INSTALL CONF FILE START ####

        CONF_DIR=$DIR/etc/shadowfog
        mkdir -p $CONF_DIR

        cp ../openwrt/shadowfog-libev/files/router-restart.json $CONF_DIR/
        cp ../openwrt/shadowfog-libev/files/dnslist.pac         $CONF_DIR/
        cp ../openwrt/shadowfog-libev/files/dnslist.pac.sha256  $CONF_DIR/
        cp $UPDATE_DIR/router-update.json                       $CONF_DIR/

        mkdir -p $DIR/etc/dnsmasq.d
        cp ../openwrt/shadowfog-libev/files/whitelist.conf      $DIR/etc/dnsmasq.d/

    #### INSTALL CONF FILE END   ####


    #### INSTALL INIT FILE START ####

        INIT_DIR=$DIR/etc/init.d
        mkdir -p $INIT_DIR

        cp ../openwrt/shadowfog-libev/files/shadowfog-router.init $INIT_DIR/shadowfog

    #### INSTALL INIT FILE END   ####


    #### RELEASE PACKAGE START ####

        UPDATE_PACKAGE_NAME="SHADOWFOG_${platform}_ROUTER.tar.gz"
        UPDATE_PACKAGE_JSON="SHADOWFOG_${platform}_ROUTER.json"
        UPDATE_PACKAGE_PATH="/var/www/downloads/update/release/"
        UPDATE_PACKAGE_URL="https://downloads.shadowfog.com/update/release/$UPDATE_PACKAGE_NAME"

        cd $DIR

        tar -czvf  ../$UPDATE_PACKAGE_NAME *

        UPDATE_PACKAGE_MD5=`md5sum ../$UPDATE_PACKAGE_NAME | cut -c 1-32`
        echo "$UPDATE_PACKAGE_NAME MD5:"$UPDATE_PACKAGE_MD5

        echo '{'                                                 > ../$UPDATE_PACKAGE_JSON".raw"
        echo '"fogvdn_force_update": "yes",'                    >> ../$UPDATE_PACKAGE_JSON".raw"
        echo '"fogvdn_host": "https://api.webrtc.win:6401/v1",' >> ../$UPDATE_PACKAGE_JSON".raw"
        echo '"fogvdn_version": "'${ROUTER_VERSION}'",'         >> ../$UPDATE_PACKAGE_JSON".raw"
        echo '"fogvdn_url": "'${UPDATE_PACKAGE_URL}'",'         >> ../$UPDATE_PACKAGE_JSON".raw"
        echo '"fogvdn_md5": "'${UPDATE_PACKAGE_MD5}'"'          >> ../$UPDATE_PACKAGE_JSON".raw"
        echo '}'                                                >> ../$UPDATE_PACKAGE_JSON".raw"

        base64 ../$UPDATE_PACKAGE_JSON".raw" | tr -d '\n' > ../$UPDATE_PACKAGE_JSON

        scp ../$UPDATE_PACKAGE_JSON ../$UPDATE_PACKAGE_NAME ${SERVER_ADDRESS}:${UPDATE_PACKAGE_PATH}

        cd -

    #### RELEASE PACKAGE END   ####


#### Router Release END   ####



#### Server Release START ####

    #### MAKE UPDATE CONF START ####

        SERVER_VERSION=35
        UPDATE_DIR=release/update
        SERVER_UPDATE_JSON=$UPDATE_DIR/server-update.json
        PACKAGE_NAME='SHADOWFOG_'${platform}'_SERVER'

        mkdir -p $UPDATE_DIR
        echo  -n '{"package":"'${PACKAGE_NAME}'.json",'  > $SERVER_UPDATE_JSON
        echo  -n '"version":"'$SERVER_VERSION'"}'       >> $SERVER_UPDATE_JSON

    #### MAKE UPDATE CONF END   ####


    DIR=release/server
    mkdir -p $DIR

    #### INSTALL BINARY FILE START ####

        BIN_DIR=$DIR/usr/bin
        mkdir -p $BIN_DIR
 
        cp ./shadowfog_restart/shadowfog_restart  $BIN_DIR/
        cp ./shadowfog_update/shadowfog_update    $BIN_DIR/
        cp ./src/ss-manager             $BIN_DIR/
        cp ./src/ss-server              $BIN_DIR/

    #### INSTALL BINARY FILE END   ####


    #### INSTALL CONF FILE START ####

        CONF_DIR=$DIR/etc/shadowfog
        mkdir -p $CONF_DIR

        cp ../openwrt/shadowfog-libev/files/server-restart.json $CONF_DIR/
        cp ../openwrt/shadowfog-libev/files/manager.json        $CONF_DIR/manager.json
        cp $UPDATE_DIR/server-update.json                       $CONF_DIR/

    #### INSTALL CONF FILE END   ####


    #### INSTALL INIT FILE START ####

        INIT_DIR=$DIR/etc/init.d
        mkdir -p $INIT_DIR

        cp ../openwrt/shadowfog-libev/files/shadowfog-server.init $INIT_DIR/shadowfog-server

    #### INSTALL INIT FILE END   ####


    #### RELEASE PACKAGE START ####

        UPDATE_PACKAGE_NAME="SHADOWFOG_${platform}_SERVER.tar.gz"
        UPDATE_PACKAGE_JSON="SHADOWFOG_${platform}_SERVER.json"
        UPDATE_PACKAGE_PATH="/var/www/downloads/update/release/"
        UPDATE_PACKAGE_URL="https://downloads.shadowfog.com/update/release/$UPDATE_PACKAGE_NAME"

        cd $DIR

        tar -czvf  ../$UPDATE_PACKAGE_NAME *

        UPDATE_PACKAGE_MD5=`md5sum ../$UPDATE_PACKAGE_NAME | cut -c 1-32`
        echo "$UPDATE_PACKAGE_NAME MD5:"$UPDATE_PACKAGE_MD5

        echo '{'                                                 > $UPDATE_PACKAGE_JSON".raw"
        echo '"fogvdn_force_update": "yes",'                    >> $UPDATE_PACKAGE_JSON".raw"
        echo '"fogvdn_host": "https://api.webrtc.win:6401/v1",' >> $UPDATE_PACKAGE_JSON".raw"
        echo '"fogvdn_version": "'${SERVER_VERSION}'",'         >> $UPDATE_PACKAGE_JSON".raw"
        echo '"fogvdn_url": "'${UPDATE_PACKAGE_URL}'",'         >> $UPDATE_PACKAGE_JSON".raw"
        echo '"fogvdn_md5": "'${UPDATE_PACKAGE_MD5}'"'          >> $UPDATE_PACKAGE_JSON".raw"
        echo '}'                                                >> $UPDATE_PACKAGE_JSON".raw"

        base64 $UPDATE_PACKAGE_JSON".raw" | tr -d '\n' > ../$UPDATE_PACKAGE_JSON

        scp ../$UPDATE_PACKAGE_JSON ../$UPDATE_PACKAGE_NAME ${SERVER_ADDRESS}:${UPDATE_PACKAGE_PATH}

        cd -

    #### RELEASE PACKAGE END   ####

#### Server Release END   ####













