/*
 * shadowfog_configure.h - Provide global definitions
 *
 * Copyright (C) 2013 - 2016, Max Lv <max.c.lv@gmail.com>
 *
 * This file is part of the shadowsocks-libev.
 * shadowsocks-libev is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * shadowsocks-libev is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with shadowsocks-libev; see the file COPYING. If not, see
 * <http://www.gnu.org/licenses/>.
 */

#ifndef _PEAR_CONFIGURE_H
#define _PEAR_CONFIGURE_H


#define  PEAR_PRODUCT_NAME  						"ShadowFog"

#define  DISK_MIN_SIZE								5000			// unit: Mb

#define  PEAR_TIMEOUT_DISK_MONITOR		 			5				// 

#define  PEAR_TIMEOUT_UPDATE_OUTSIDE    			(60 * 5)  // (60) FOR DEBUG

#define  PEAR_TIMEOUT_DUMP_STATUS_INIT  			1
#define  PEAR_TIMEOUT_DUMP_STATUS       			(60 * 1)

#define  PEAR_TIMEOUT_SPEED_TEST_INIT   			30
#define  PEAR_TIMEOUT_SPEED_TEST        			(60 * 30)

#define  PEAR_TOKEN_EXPIRED             			(7 * 60 * 60) 	// 7 hours


/*
 *		platform name
 */
/*
#if (PLATFORM_TYPE == 0)
	#define PLATFORM "PEAR_X64_UBUNTU"
#elif (PLATFORM_TYPE == 1)
	#define PLATFORM "PEAR_X86_UBUNTU"
#elif (PLATFORM_TYPE == 2)
	#define PLATFORM "QNAP_X64_UBUNTU"
#elif (PLATFORM_TYPE == 3)
	#define PLATFORM "QNAP_X86_UBUNTU"
#elif (PLATFORM_TYPE == 4)
	#define PLATFORM "QNAP_ARM64_UBUNTU"
#elif (PLATFORM_TYPE == 5)
	#define PLATFORM "QNAP_ARM32_UBUNTU"
#elif (PLATFORM_TYPE == 6)
	#define PLATFORM "NEWIFI_MT7621_OPENWRT"
#elif (PLATFORM_TYPE == 7)
	#define PLATFORM "MINI_MT7621_OPENWRT"
#else
	#error "PLATFORM DEFINE ERROR"
#endif
*/


#define WORKING_DIR	"/tmp"


#define PEAR_MAX_SS_SERVER   							50


#define PEAR_EXTERNAL_HTTP_RAW      					0
#define PEAR_EXTERNAL_HTTP_JSON     					1
#define PEAR_EXTERNAL_HTTP_XML      					2


#define PEAR_EXIT_CODE_DISK_SWITCH						-1

#define PEAR_EXIT_CODE_CACHE_PARITION_NOT_ENOUGH		-2

#define PEAR_EXIT_CODE_CACHE_PARITION_CHNAGE			-3

#define PEAR_EXIT_CODE_PTHREAD_CREATE					-4


#ifndef SOL_TCP
#define SOL_TCP IPPROTO_TCP
#endif

#if defined(MODULE_TUNNEL) || defined(MODULE_REDIR)
#define MODULE_LOCAL
#endif

#ifdef ANDROID
int protect_socket(int fd);
int send_traffic_stat(uint64_t tx, uint64_t rx);
#endif


#define  PEAR_SUPPORT_QNAP_PATH_ROOT        "/share/CACHEDEV1_DATA/.qpkg"
#define  PEAR_SUPPORT_QNAP_PATH             "/share/CACHEDEV1_DATA/.qpkg/shadowfog/shadowfog"

#define  PEAR_ENABLE_CHANGE_PASSWD  					0
#define  PERR_SERVRE_ERROR_NUMBER   					20
#define  PEAR_CURL_ENABLE_TSL  							1


#endif // _COMMON_H




