#ifndef __PEAR_MACHINE_H_
#define __PEAR_MACHINE_H_

#include "shadowfog_version.h"
#include "jconf.h"


enum HARDWARE_PLATFORM {

    HARDWARE_PLATFORM_PEAR  = 0,

    HARDWARE_PLATFORM_QNAP  = 1

};

enum NODE_TYPE {

    NODE_TYPE_NODE = 0,

    NODE_TYPE_SERVER = 1,

    NODE_TYPE_BROWSER = 2
};


typedef struct {

    int  init_ok ;
    
    // port mapping(don't need, need: upnp mapping, pmp mapping)
    //
    int is_public_ip;

    int  max_server;

    char extern_ip[128];

    char host_ip[128];          // api server: such as "http://192.168.1.130:8090/v1"

    char local_ip[128];         // router wan ip, such as 192.168.1.105

    char mac[128];              // net mac address

	char working_dir[64];

    enum HARDWARE_PLATFORM  hardware_platform;
    
    char  platform[128];                            // for software update

    enum NODE_TYPE node_type;

} shadowfog_machine_info_t;


extern shadowfog_machine_info_t shadowfog_machine_info;


void shadowfog_machine_info_init(void);


void shadowfog_machine_get_external_ip(char * value);


void shadowfog_machine_get_local_ip(char *buf, int buflen);


int  shadowfog_machine_get_mac(char * mac_address);


int shadowfog_get_host(void);


#endif

