#include "shadowfog_option.h"


shadowfog_option_info_t shadowfog_option_info;


void shadowfog_getopt(int argc, char *argv[])
{
	int arg;

	memset(&shadowfog_option_info, 0, sizeof(shadowfog_option_info));

	while ((arg = getopt(argc, argv, "c:C:dDvVsShH")) != -1) {
	
		switch (arg) {
            // config file
            case 'c':
            case 'C':
                shadowfog_option_info.conf_file = optarg;
                break;

			// debug
			//
			case 'd':
			case 'D':
				shadowfog_option_info.debug = 1;
				break;
		
			// version
			//
			case 'v':
			case 'V':
				fprintf(stdout, "current version: %s\n", SHADOWFOG_VERSION);
				exit(1);

			// help
			//
			case 'h':
			case 'H':
				fprintf(stdout, "please run \"%s [-d, -D]\"to see debug\n", argv[0]);
				fprintf(stdout, "please run \"%s [-v, -V]\"to see version\n", argv[0]);
				exit(1);
			
			default:
				fprintf(stdout, "please run \"%s -h\" to ask for help\n", argv[0]);
				exit(1);
   		}
	}
}
