#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include "shadowfog_update.h"
#include "shadowfog_event.h"


shadowfog_update_info_t shadowfog_update_info;


void shadowfog_update_init()
{
    if (!shadowfog_option_info.debug) {

        int fd = open("/dev/null", O_WRONLY);

        if (fd < 0) {

            exit(1);
        }

        dup2(fd, 1);

        dup2(fd, 2);
    }

    //
    //
    memset(&shadowfog_update_info, 0, sizeof(shadowfog_update_info_t));

    // 
    //
#if PEAR_CURL_ENABLE_TSL
    shadowfog_update_info.curl = "curl --insecure -fsSL --connect-timeout  10 -m 30 --header \"Content-Type: application/json\"  --header \"Cache-Control: no-cache\" ";
#else
    shadowfog_update_info.curl = "curl --connect-timeout  10  -m 20 --header \"Content-Type: application/json\"  --header \"Cache-Control: no-cache\" ";
#endif

    //
    // 
    // sprintf(shadowfog_log_info.logfile, "/etc/shadowfog/shadowfog_share/shadowfog_update.log");

    // 
    //
    shadowfog_machine_info_init();

    //
    //
    //shadowfog_get_host();
}


static void shadowfog_parse_config_file()
{
    char buf[512] = {0x00};

    FILE *fp = fopen(shadowfog_option_info.conf_file, "r");

    if (fp == NULL)
    {
        PEAR_LOG(UPDATE, DEBUG, "Open file error");
        exit(0);
    }

    if (fread(buf, sizeof(char), 512, fp) < 0)
    {
        PEAR_LOG(UPDATE, DEBUG, "Read file error");
        exit(0);
    }
    shadow_get_json(buf, "package", shadowfog_update_info.package);
    shadow_get_json(buf, "version", shadowfog_update_info.version);
    printf("package:%s, version:%s\n", shadowfog_update_info.package, shadowfog_update_info.version);
}


// fuqiyang 2017-05-15
//
int main(int argc, char **argv)
{
	// get opt
	//
    USE_SYSLOG(argv[0]);
	shadowfog_getopt(argc, argv);

    if (shadowfog_option_info.conf_file == NULL)
    {
        printf("need -c config file");
        exit(0);
    }


    // set signals 
    //
    shadowfog_set_signals();

    //
    //
    shadowfog_event_init();

    // initialize ev loop
	//
    shadowfog_event_set_signals_for_update();

    // init
    //
    shadowfog_update_init();

    shadowfog_parse_config_file();

    //
    //
	shadowfog_event_set_update_timer();

    // start ev loop
    //
    shadowfog_event_run();

#ifdef __MINGW32__
    winsock_cleanup();
#endif

    //
    //
    shadowfog_event_stop();

    return 0;
}
