#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <time.h>
#include <stdint.h>

#include <linux/kernel.h>
#include <stdio.h>
#include <sys/sysinfo.h>
#include <sys/vfs.h>
#include <sys/un.h>
#include <sys/socket.h>
#include <pwd.h>

#include <sys/ioctl.h>
#include <net/if.h>
#include <sys/wait.h>

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>


#include <sys/utsname.h>

#include <mntent.h>
#include <errno.h>
#include <unistd.h>
#include <assert.h>
#include <dirent.h>
#include "shadowfog_utils.h"


int shadowfog_mkdir(const char *file_name, int is_dir)
{
    char tmp[512];

    strcpy(tmp, file_name);

    if (!is_dir) {

        char *ch = strrchr(tmp, '/');

        *ch = 0;
    }

    //PEAR_LOG(MAIN, DEBUG, "mkdir full path: %s", dir);

    int  i;
    for (i = 1; tmp[i] != '\0'; i++) {

        if (tmp[i] == '/')  {

            tmp[i] = 0;

            if (access(tmp, F_OK) != 0) {

                mkdir(tmp, S_IRWXU | S_IRWXG | S_IROTH | S_IXOTH);

                //PEAR_LOG(MAIN, DEBUG, "mkdir: %s", tmp);
            }

            tmp[i] = '/';
        }
    }
    if (access(tmp, F_OK) != 0) {

        mkdir(tmp, S_IRWXU | S_IRWXG | S_IROTH | S_IXOTH);

        //PEAR_LOG(MAIN, DEBUG, "mkdir: %s", tmp);
    }
    return 0;
}


static size_t WriteMemoryCallback(void *contents, size_t size, size_t nmemb, void *userp)
{
    size_t realsize = size * nmemb;
    struct MemoryStruct *mem = (struct MemoryStruct *)userp;

    mem->memory = realloc(mem->memory, mem->size + realsize + 1);
    if (mem->memory == NULL) {
        /* out of memory! */
        printf("not enough memory (realloc returned NULL)\n");
        return 0;
    }

    memcpy(&(mem->memory[mem->size]), contents, realsize);
    mem->size += realsize;
    mem->memory[mem->size] = 0;

    return realsize;
}



int shadowfog_ddns_init_conf(shadowfog_ddns_conf_t *conf)
{
    strncpy(conf->login_token, "12079,84f7755f2464126c6757dd10eac202e4", sizeof(conf->login_token));
    strncpy(conf->format, "json", sizeof(conf->format));
    strncpy(conf->domain, "supear.cn", sizeof(conf->domain));
    strncpy(conf->user_agent, "DDNS Client/1.0.0 (shadow.fog@yandex.ru)", sizeof(conf->user_agent));
    return 0;
}


int shadowfog_ddns_query(shadowfog_ddns_req_t *req, shadowfog_ddns_rsp_t *rsp)
{
    CURL *curl_handle;
    CURLcode res;
    curl_handle = curl_easy_init();
    rsp->memory = malloc(1);  /* will be grown as needed by the realloc above */
    rsp->size = 0;            /* no data at this point */

    curl_global_init(CURL_GLOBAL_ALL);
    curl_easy_setopt(curl_handle, CURLOPT_WRITEFUNCTION, WriteMemoryCallback);
    curl_easy_setopt(curl_handle, CURLOPT_WRITEDATA, (void *)rsp);
    curl_easy_setopt(curl_handle, CURLOPT_USERAGENT, req->conf->user_agent);
    /*curl_easy_setopt(curl_handle, CURLOPT_SSL_VERIFYPEER, 0L); CURLOPT_SSL_VERIFYHOST: on!*/
    curl_easy_setopt(curl_handle, CURLOPT_SSL_VERIFYHOST, 2L);

// #if DEBUG_LESS_FEATURE
    curl_easy_setopt(curl_handle, CURLOPT_TIMEOUT, 3);
// #endif

    curl_easy_setopt(curl_handle, CURLOPT_URL, req->api_url);
    if (strlen(req->query_str) > 0) {
        curl_easy_setopt(curl_handle, CURLOPT_POSTFIELDS, req->query_str);
    }

    res = curl_easy_perform(curl_handle);

    /*
    if(res != CURLE_OK)
    {
        fprintf(stderr, "curl_easy_perform() failed: %s\n",
                curl_easy_strerror(res));
    }
    else
    {
        printf("%lu bytes retrieved\n", (unsigned long)rsp->size);
        printf("%s\n", rsp->memory);
    }
    */

    curl_easy_cleanup(curl_handle);
    /* free(chunk.memory); Do not free here! Should release in application*/
    curl_global_cleanup();
    return res;
}


int is_directory(const char *path)
{
    struct stat statbuf;
    if (stat(path, &statbuf) != 0)
        return 0;
    return S_ISDIR(statbuf.st_mode);
}
/*
man 2 stat:
if (stat(argv[1], &sb) == -1) {
   perror("stat");
   exit(EXIT_FAILURE);
}
*/


//  cat /proc/cpuinfo more details for openwrt
//
void detect_hardware_platform()
{
    sprintf(shadowfog_machine_info.platform, "%s", PLATFORM);
}


char shadowfog_log_temp[4096];

void shadowfog_log_file(const char *msg)
{
    
}









