#ifndef _PEAR_UTILS_H
#define _PEAR_UTILS_H

#include "shadowfog_curl.h"
#include "shadowfog_machine.h"

enum {

    PEAR_DDNS_ERR_MEM_OVERFLOW = -9,

    PEAR_DDNS_ERR_PARAMETER,

    PEAR_DDNS_ERR_TIMEOUT,

    PEAR_DDNS_ERR_GET_CLIENT_INFO,

    PEAR_DDNS_ERR_MESSAGE,

    PEAR_DDNS_ERR_NO_RECORD,

    PEAR_DDNS_ERR_UNKNOWN
};


typedef struct {

    char login_token[64];

    char format     [8];

    char domain     [56];

    char user_agent [64];

} shadowfog_ddns_conf_t;


typedef struct {

    shadowfog_ddns_conf_t *conf;

    char api_url   [64];

    char query_str [512];

    char domain    [56];

} shadowfog_ddns_req_t;


typedef struct MemoryStruct {

    char *memory;

    size_t size;

} shadowfog_ddns_rsp_t;


typedef struct {

    shadowfog_ddns_req_t *req;

    shadowfog_ddns_rsp_t *rsp;

} shadowfog_ddns_req_cxt_t;



int shadowfog_ddns_init_conf(shadowfog_ddns_conf_t *conf);


int shadowfog_ddns_query(shadowfog_ddns_req_t *req, shadowfog_ddns_rsp_t *rsp);


void detect_hardware_platform();


int shadowfog_mkdir(const char *file_name, int is_dir);


void shadowfog_log_file(const char *msg);


#endif



