#include "shadowfog_version.h"
#include <stdio.h>

// https://git.oschina.net/ShadowFogNetwork/Information/raw/master/ss-manager.json
// By default, `make install' installs the package's commands under `/usr/local/bin'
//
shadowfog_version_info_t shadowfog_version_info;
char *current_version;

/*
char *shadowfog_host_address[] = {
    "https://update.webrtc.win/",
    "http://update.webrtc.win/",
    "https://update.pear.hk/",
    "http://update.pear.hk/",
    "https://update.pear.ac.cn/",
    "http://update.pear.ac.cn/",
    "https://raw.githubusercontent.com/ShadowFog/Information/master/",
    "https://raw.githubusercontent.com/fuqiyang11/Node-update/master/",
    "https://git.oschina.net/FogVDN/Node-update/raw/master/",
};
*/
/*
char *shadowfog_host_address[] = {
    "https://shadowfog.com/Terminal_Update/",
    "https://update.shadowfog.com/Terminal_Update/",
};
*/
char *shadowfog_host_address[] = {
    "https://downloads.shadowfog.com/update/release/"
};

// char *shadowfog_host_address[] = {
 
//     "https://qqqq.webrtc.win/",

//     "http://qqqq.webrtc.win/",

//     "https://update.webrtc.win/",

//     "http://update.webrtc.win/",
// };


int get_host_address_number(void)
{
    return (int)(sizeof(shadowfog_host_address) / sizeof(shadowfog_host_address[0]));
}


/*
curl https://git.oschina.net/ShadowFogNetwork/Information/raw/master/ss-manager --output shit
md5sum ./ss-manager
4cd828dce34f317b3f0ccfd01f6ab497
 ll ./ss-manager
-rw-rw-r-- 1
*/

int shadowfog_md5(const char *filename, char *out)
{
    int n;
    unsigned char c[MD5_DIGEST_LENGTH];
    FILE *inFile = fopen (filename, "rb");
    MD5_CTX mdContext;
    int bytes;
    unsigned char data[1024];


    if (inFile == NULL) {
        printf ("%s can't be opened.\n", filename);
        return 0;
    }

    MD5_Init (&mdContext);
    while ((bytes = fread (data, 1, 1024, inFile)) != 0)
        MD5_Update (&mdContext, data, bytes);
    MD5_Final (c, &mdContext);

    for (n = 0; n < 16; ++n) {
        snprintf(&(out[n * 2]), 16 * 2, "%02x", (unsigned int)c[n]);
    }

    //for(i = 0; i < MD5_DIGEST_LENGTH; i++) printf("%02x", c[i]);
    printf (" %s\n", filename);
    fclose (inFile);
    return 0;

}

/*
*   md5 32位加密
*
*   zhenbin 2017.03.24
*/

int shadowfog_md5_32(char *in, char *out)
{

    char data[1024]= {0};
    unsigned char md5[16]= {0x00};
    char buf[33]= {'\0'};
    char tmp[3] = {'\0'};

    strcpy(data, in);

    MD5_CTX ctx;

    MD5_Init(&ctx);
    MD5_Update(&ctx, data, strlen(data));
    MD5_Final(md5, &ctx);

    int i;
    for(i=0; i<16; i++) {
        sprintf(tmp, "%02X", md5[i]);
        strcat(buf, tmp);
    }
    strcpy(out, buf);

    return 1;

}


// fuqiyang
// host: such as "https://api.webrtc.win:6401/v1", from json packet
// mac:
// extern_ip: 
//
static int shadowfog_update_check (const char *host, const char *mac, const char *extern_ip)
{
    char url [512] = {0x00};
    char recvbuf[4096] = {0x00};
    long retcode;

    sprintf(url, "%s/node/version?mac=%s&ip=%s", host, mac, extern_ip);

    char header_content_type[64] = "Content-Type: application/json";
    char header_cache_control[64] = "Cache-Control: no-cache";
    char *header[] = { &header_content_type, &header_cache_control, NULL };
 
    retcode = shadowfog_curl_cmd("GET", url, NULL, header, 0, 0, recvbuf, NULL);

    if (retcode != 200) {

        //TODO
        // PEAR_LOG(UPDATE, ERR, "ask api server to update: %s", recvbuf);
        return 0;
    }

    //{"code":"0","msg":"success","update":"true"}
    //
    char update[10] = {0x00};

    shadow_get_json(recvbuf, "update", update);

    if (strcmp(update, "true") == 0) { return 1; }

    return 0;

}


// fuqiyang
//
static void shadowfog_update_do(void)
{
    long retcode;
    size_t file_size;
    char cmd[512] = {0x00};
    // check version number
    //
    if (atoi(current_version) >= atoi(shadowfog_version_info.version)) {

        PEAR_LOG(UPDATE, DEBUG, "current version: %s, remote version: %s, don't need update program", current_version, shadowfog_version_info.version);

        return;
    }

    // PEAR_LOG(UPDATE, DEBUG, "begin updating , and now version is %s ", current_version);

    char outputfile [256] = {0x00};

    sprintf(outputfile, "%s/%s.tar.gz", WORKING_DIR, PEAR_PRODUCT_NAME);

    char file_buf[3000000] = {0x00};

    char header_content_type[64] = "Content-Type: application/json";
    char header_cache_control[64] = "Cache-Control: no-cache";
    char *header[] = { &header_content_type, &header_cache_control, NULL };

    LOGI("[shadowfog-version] Start Download Package");
    retcode = shadowfog_curl_cmd("GET", shadowfog_version_info.url, NULL, header, NULL, 0, file_buf, &file_size);

    if (retcode != 200)
    {
        PEAR_LOG(UPDATE, DEBUG, "retcode: %ld", retcode);
        return;
    }
    else
    {
        PEAR_LOG(UPDATE, DEBUG, "file_size: %d", file_size);
    }

    FILE *fp = fopen(outputfile, "w+");

    if (fp == NULL)
    {
        fprintf(stderr, "fopen failed!");
    }

    fwrite(file_buf, sizeof(char), file_size, fp);

    fclose(fp);

    // parity md5 value
    //
    char outputfile_md5[33];

    shadowfog_md5(outputfile, outputfile_md5);

    PEAR_LOG(UPDATE, DEBUG, "update the md5 is %s  and expect is %s", outputfile_md5, shadowfog_version_info.md5);

    if (strcmp(shadowfog_version_info.md5, outputfile_md5) != 0) {

        PEAR_LOG(UPDATE, ERR, "the md5 is wrong, file maybe broken, so do nothing");

        return;
    }

    PEAR_LOG(UPDATE, DEBUG, "file is ok , the md5 is %s  and expect is %s", outputfile_md5, shadowfog_version_info.md5);

    sprintf(cmd, "tar -zxvf %s -C /", outputfile);

    if (system(cmd) < 0)
    {
        PEAR_LOG(UPDATE, INFO, "%s ERROR", cmd);
    }

    PEAR_LOG(UPDATE, INFO, "update finish, exit...");

    exit(0);
}


// curl + shadowfog_host_address: to get json file in remote server
// host + mac + extern_ip: to ask remote server if need updating
// shadowfog_version_info.version + shadowfog_version_info.url + shadowfog_version_info.md5 + out_force_update: store from json file in remote server
//
void shadowfog_update(const char *curl, const char *host, const char *mac, const char *extern_ip, const char *package, const char *version)
{
    char cmd[512]   = {0x00};
    char url[256]   = {0x00};
    char temp[4096] = {0x00};
    char base64_temp[1024] = {0x00};
    FILE * pipe_reader;

    current_version = version;
    int items = get_host_address_number();

    int i = 0;

    for (i = 0; i < items; i++) {
        
        sprintf(url, "%s%s", shadowfog_host_address[i], package);
        sprintf(cmd, "%s -X GET %s", curl, url);
        PEAR_LOG(UPDATE, DEBUG, "[shadowfog_update] update %d : get host cmd: %s, package:%s, version: %s", i, cmd, package, version);
        memset(&shadowfog_version_info, 0x00, sizeof(shadowfog_version_info));
        pipe_reader = popen(cmd, "r");
        int i = fread(temp, 1, 4096, pipe_reader);
        pclose(pipe_reader);
        if (i <= 0) { continue; }

        Base64decode(base64_temp, temp);
        
        PEAR_LOG(UPDATE, DEBUG, "read feedback bytes %d , and content : %s", i, temp);

        if (strstr(base64_temp, "fogvdn_host")) {

            shadow_get_json(base64_temp, "fogvdn_host", shadowfog_version_info.host);
            shadow_get_json(base64_temp, "fogvdn_version", shadowfog_version_info.version);
            shadow_get_json(base64_temp, "fogvdn_url", shadowfog_version_info.url);
            shadow_get_json(base64_temp, "fogvdn_md5", shadowfog_version_info.md5);
            shadow_get_json(base64_temp, "fogvdn_force_update", shadowfog_version_info.force_update);

            // if force_update is "yes", skip the process(not ask api_server)
            //
            if (strstr(shadowfog_version_info.force_update, "yes")) {

                PEAR_LOG(UPDATE, DEBUG, "force to update(not need to ask api_server)");
            }
            // ask api_server whether need update
            //
            else if (!shadowfog_update_check(shadowfog_version_info.host, mac, extern_ip)) {

                PEAR_LOG(UPDATE, DEBUG, "api_server not permit to update");

                return;
            }

            // download update package
            //
            if (strlen(shadowfog_version_info.url)) {

        		PEAR_LOG(UPDATE, DEBUG, "update %s ", shadowfog_version_info.version);

        		PEAR_LOG(UPDATE, DEBUG, "update %s ", shadowfog_version_info.url);

        		PEAR_LOG(UPDATE, DEBUG, "update %s ", shadowfog_version_info.md5);

                shadowfog_update_do();
            }

            break;
        }
        memset(base64_temp, 0x00, 1024);
        memset(temp, 0x00, 4096);
    }
}






