#ifndef _PEAR_VERSION_H
#define _PEAR_VERSION_H

#include <stdio.h>
#include <string.h>
#include <openssl/md5.h>
#include "shadowfog_configure.h"
#include "base64.h"
#include "utils.h"
#include "shadowfog_curl.h"
#include "shadowfog_json.h"

#define  SHADOWFOG_VERSION   "100"


typedef struct {

    char md5[64];
    char url[512];
    char host[512];
    char version[64];
    char force_update[16];

} shadowfog_version_info_t;


extern shadowfog_version_info_t shadowfog_version_info;


extern char *shadowfog_host_address[];


int get_host_address_number(void);


int shadowfog_md5(const char *filename, char *out);


int shadowfog_md5_32(char *in, char *out);


void shadowfog_update(const char *curl, const char *host, const char *mac, const char *extern_ip, const char *package, const char *version);


#endif





