#ifndef _PEAR_FOG_INFO_H
#define _PEAR_FOG_INFO_H

#define PEAR_MAX_SS_SERVER 50

enum HARDWARE_PLATFORM
{
    HARDWARE_PLATFORM_PEAR     = 0,
    HARDWARE_PLATFORM_QNAP     = 1,
    HARDWARE_PLATFORM_OPENWRT  = 2
};

enum NET_TYPE
{
    NET_TYPE_GI  = 0,
    NET_TYPE_EDU = 1,
    NET_TYPE_DC  = 2,
};

typedef struct {
    int  pmp;
    int  upnp;
    int  init_ok;
    int  max_server;
    int  cpu_number;
    int  is_public_ip;
    int  is_support_pmp;
    int  is_support_upnp;

    char host_ip[128];
    char local_ip[128];
    char extern_ip[128];
    char old_extern_ip[128];

    // cpu serial number
    char psn[128];

    // mac address
    char mac[128];

    // unit is  M
    char memery[32];
    enum NET_TYPE  net_type;

    // for software update
    char platform[128];
    enum HARDWARE_PLATFORM  hardware_platform;

    char passwd[64];
    char shellresult[4096];
} shadowfog_fog_info_t;

extern shadowfog_fog_info_t shadowfog_fog_info;

void shadowfog_fog_info_init();
void shadowfog_fog_info_detect();

#endif
