#include <stdio.h>
#include <string.h>

#include "shadowfog_log.h"
#include "shadowfog_json.h"
#include "shadowfog_curl.h"
#include "shadowfog_base64.h"

static int shadowfog_ping (char * host);

static char *shadowfog_curl_header[] = {
    "Content-Type: application/json",
    "Cache-Control: no-chache",
     NULL
};

int shadowfog_get_host(char *real_host, char *host_address[], int items, char *host_name)
{
    int s = 0;
    int i = 0;
    int j = 0;

    char temp[4096]        = {0x00};
    char temp_host[1024]   = {0x00};
    char base64_temp[1024] = {0x00};

    LOGI("host address item is %d", items);

    for (i = 0; i < items; i++)
    {
        s = shadowfog_curl_cmd("GET", host_address[i], NULL, shadowfog_curl_header, NULL, 0, temp);
        if (s < 0)
        {
            continue;
        }

        LOGI("[sf-host] shadowfog_curl_cmd: URL: %s, recv bytes:%d, content:%s", host_address[i], s, temp);

        memset(base64_temp, 0x00, 1024);
        Base64decode(base64_temp, temp);

        for (j = strlen(base64_temp) - 1; j > 0; j--)
        {
            LOGI("[ss-fog-info] base64 cut: %s", base64_temp + j);
            if (base64_temp[j] == '\n')
            {
                base64_temp[j] = 0;
            }
            else
            {
                break;
            }

        }

        LOGI("[sf-host] After base64 decode the content: %s", base64_temp);

        if (shadowfog_json_get_string(base64_temp, host_name, temp_host) > 0)
        {
            LOGI("[sf-host] Get host address: %s", temp_host);

            if (!shadowfog_ping(temp_host))
            {
                strcpy(real_host, temp_host);
                return 0;
            }
            // temp function do not check ping-pong
            strcpy(real_host, temp_host);
            return 0;
        }

        memset(temp, 0x00, 4096);
    }

    LOGI("[sf-host] GET HOST ERROR ,exit: -1, but only return");

    return -1;
}

static int shadowfog_ping (char * host)
{
    int  s = 0;
    char cmd [512]  = {0x00};
    char temp[4096] = {0x00};

    sprintf(cmd ,"%s/fogs", host);
    LOGI("[sf-host] Ping cmd: %s", cmd);
 
    s = shadowfog_curl_cmd("GET", cmd, NULL, shadowfog_curl_header, NULL, 0, temp);
    if (s < 0)
    {
        return -1;
    }

    LOGI("read feedback bytes %d , and content : %s", s, temp);

    if(strstr(temp,"pong"))
    {
        LOGI("[sf-host] ping get pong!");
        return 0;
    }

    return -1;
}
