#include <string.h>
#include <stdio.h>
#include <getopt.h>
#include <errno.h>
#include <stdlib.h>
#include <unistd.h>
#include <openssl/ssl.h>

#ifdef HAVE_PCRE_H
#include <pcre.h>
#elif HAVE_PCRE_PCRE_H
#include <pcre/pcre.h>
#endif
#include <pcre.h>

//#include "utils.h"
#include "shadowfog_log.h"
#include "shadowfog_curl.h"
#include "shadowfog_base64.h"
#include "sodium/crypto_hash_sha256.h"

#define LIST_DEBUG 0

#define BUF_SIZE 1000000

char google_url[] = "facebookblueprint.com\ngoogle.com\ngoogle.ad\ngoogle.ae\ngoogle.com.af\ngoogle.com.ag\ngoogle.com.ai\ngoogle.al\ngoogle.am\ngoogle.co.ao\ngoogle.com.ar\ngoogle.as\ngoogle.at\ngoogle.com.au\ngoogle.az\ngoogle.ba\ngoogle.com.bd\ngoogle.be\ngoogle.bf\ngoogle.bg\ngoogle.com.bh\ngoogle.bi\ngoogle.bj\ngoogle.com.bn\ngoogle.com.bo\ngoogle.com.br\ngoogle.bs\ngoogle.bt\ngoogle.co.bw\ngoogle.by\ngoogle.com.bz\ngoogle.ca\ngoogle.cd\ngoogle.cf\ngoogle.cg\ngoogle.ch\ngoogle.ci\ngoogle.co.ck\ngoogle.cl\ngoogle.cm\ngoogle.cn\ngoogle.com.co\ngoogle.co.cr\ngoogle.com.cu\ngoogle.cv\ngoogle.com.cy\ngoogle.cz\ngoogle.de\ngoogle.dj\ngoogle.dk\ngoogle.dm\ngoogle.com.do\ngoogle.dz\ngoogle.com.ec\ngoogle.ee\ngoogle.com.eg\ngoogle.es\ngoogle.com.et\ngoogle.fi\ngoogle.com.fj\ngoogle.fm\ngoogle.fr\ngoogle.ga\ngoogle.ge\ngoogle.gg\ngoogle.com.gh\ngoogle.com.gi\ngoogle.gl\ngoogle.gm\ngoogle.gp\ngoogle.gr\ngoogle.com.gt\ngoogle.gy\ngoogle.com.hk\ngoogle.hn\ngoogle.hr\ngoogle.ht\ngoogle.hu\ngoogle.co.id\ngoogle.ie\ngoogle.co.il\ngoogle.im\ngoogle.co.in\ngoogle.iq\ngoogle.is\ngoogle.it\ngoogle.je\ngoogle.com.jm\ngoogle.jo\ngoogle.co.jp\ngoogle.co.ke\ngoogle.com.kh\ngoogle.ki\ngoogle.kg\ngoogle.co.kr\ngoogle.com.kw\ngoogle.kz\ngoogle.la\ngoogle.com.lb\ngoogle.li\ngoogle.lk\ngoogle.co.ls\ngoogle.lt\ngoogle.lu\ngoogle.lv\ngoogle.com.ly\ngoogle.co.ma\ngoogle.md\ngoogle.me\ngoogle.mg\ngoogle.mk\ngoogle.ml\ngoogle.com.mm\ngoogle.mn\ngoogle.ms\ngoogle.com.mt\ngoogle.mu\ngoogle.mv\ngoogle.mw\ngoogle.com.mx\ngoogle.com.my\ngoogle.co.mz\ngoogle.com.na\ngoogle.com.nf\ngoogle.com.ng\ngoogle.com.ni\ngoogle.ne\ngoogle.nl\ngoogle.no\ngoogle.com.np\ngoogle.nr\ngoogle.nu\ngoogle.co.nz\ngoogle.com.om\ngoogle.com.pa\ngoogle.com.pe\ngoogle.com.pg\ngoogle.com.ph\ngoogle.com.pk\ngoogle.pl\ngoogle.pn\ngoogle.com.pr\ngoogle.ps\ngoogle.pt\ngoogle.com.py\ngoogle.com.qa\ngoogle.ro\ngoogle.ru\ngoogle.rw\ngoogle.com.sa\ngoogle.com.sb\ngoogle.sc\ngoogle.se\ngoogle.com.sg\ngoogle.sh\ngoogle.si\ngoogle.sk\ngoogle.com.sl\ngoogle.sn\ngoogle.so\ngoogle.sm\ngoogle.sr\ngoogle.st\ngoogle.com.sv\ngoogle.td\ngoogle.tg\ngoogle.co.th\ngoogle.com.tj\ngoogle.tk\ngoogle.tl\ngoogle.tm\ngoogle.tn\ngoogle.to\ngoogle.com.tr\ngoogle.tt\ngoogle.com.tw\ngoogle.co.tz\ngoogle.com.ua\ngoogle.co.ug\ngoogle.co.uk\ngoogle.com.uy\ngoogle.co.uz\ngoogle.com.vc\ngoogle.co.ve\ngoogle.vg\ngoogle.co.vi\ngoogle.com.vn\ngoogle.vu\ngoogle.ws\ngoogle.rs\ngoogle.co.za\ngoogle.co.zm\ngoogle.co.zw\ngoogle.cat\n";

char blogspot_url[] = "blogspot.ca\nblogspot.co.uk\nblogspot.com\nblogspot.com.ar\nblogspot.com.au\nblogspot.com.br\nblogspot.com.by\nblogspot.com.co\nblogspot.com.cy\nblogspot.com.ee\nblogspot.com.eg\nblogspot.com.es\nblogspot.com.mt\nblogspot.com.ng\nblogspot.com.tr\nblogspot.com.uy\nblogspot.de\nblogspot.gr\nblogspot.in\nblogspot.mx\nblogspot.ch\nblogspot.fr\nblogspot.ie\nblogspot.it\nblogspot.pt\nblogspot.ro\nblogspot.sg\nblogspot.be\nblogspot.no\nblogspot.se\nblogspot.jp\nblogspot.in\nblogspot.ae\nblogspot.al\nblogspot.am\nblogspot.ba\nblogspot.bg\nblogspot.ch\nblogspot.cl\nblogspot.cz\nblogspot.dk\nblogspot.fi\nblogspot.gr\nblogspot.hk\nblogspot.hr\nblogspot.hu\nblogspot.ie\nblogspot.is\nblogspot.kr\nblogspot.li\nblogspot.lt\nblogspot.lu\nblogspot.md\nblogspot.mk\nblogspot.my\nblogspot.nl\nblogspot.no\nblogspot.pe\nblogspot.qa\nblogspot.ro\nblogspot.ru\nblogspot.se\nblogspot.sg\nblogspot.si\nblogspot.sk\nblogspot.sn\nblogspot.tw\nblogspot.ug\nblogspot.cat\ntwimg.edgesuit.net\n";

char *black_url_list[] = {
    "amazon.com",
    "githubusercontent.com",
     NULL
};

static void shadowfog_BIN_to_XX(unsigned char *bin, char *xx_str, int bin_len)
{
    int i;

    for (i = 0; i < bin_len; i++)
    {
        sprintf((char *)xx_str + i * 2, "%02x", (unsigned char)bin[i]);
    }

    *((char *)xx_str + bin_len * 2) = 0;
}

static int is_skip(char *buf)
{
    int i = 0;

	if (buf[0] == '@' || buf[0] == '!' || buf[0] == 0 || buf[0] == '/') 
	{
		return 1;
	}

	if (strstr(buf, "[") != NULL)
	{
		return 1;
	}

    for (i = 0; black_url_list[i] != NULL; i++)
    {
        if (strstr(buf, black_url_list[i]) != NULL)
        {
            return 1;
        }
    }

/*
 * IP address match
 */
	return 0;
}

char *head_cut(char *buf)
{
	char *temp = buf;
	// cut '|' or '||'
	for (; *temp == '|'; temp++);

	// cut 'http'
	if ( temp[0] == 'h' &&
	     temp[1] == 't' &&
	     temp[2] == 't' &&
	     temp[3] == 'p' &&
	     temp[4] == ':')
	{
		temp += 7;
	}

	// cut 'https'
	if ( temp[0] == 'h' &&
	     temp[1] == 't' &&
	     temp[2] == 't' &&
	     temp[3] == 'p' &&
	     temp[4] == 's' &&
	     temp[5] == ':')
	{
		temp += 8;
#if LIST_DEBUG
		printf("\n===========cuted===========\n");
#endif
	}

    // cut ^./* 
    while (temp[0] == '.' || temp[0] == '*')
    {
#if LIST_DEBUG
        printf("temp[0]: %c\n", temp[0]);
#endif
        temp++;
    }
#if LIST_DEBUG
    printf("\nend: %c\n", temp[0]);
#endif

	return temp;
}

char *tail_cut(char *buf)
{
	char *temp = buf;

	for(; *temp != 0; temp++)
	{
		if (*temp == '/')
		{
			*temp = 0;
			break;
		}
	}

	return buf;
}

int is_url(char *buf)
{
    int pcreExecRet;
    int subStrVec[30];
    int pcreErrorOffset;
    pcre *reCompiled = NULL;
    pcre_extra *pcreExtra;
    const char *pcreErrorStr = NULL;

    //char reg_str[] = "([a-zA-Z0-9][-a-zA-Z0-9]*(.[a-zA-Z0-9][-a-zA-Z0-9]*)+)";
    char reg_str[] = "(([a-zA-Z0-9][-a-zA-Z0-9.]*)+\\.[a-zA-Z][a-zA-Z]*)";

    reCompiled = pcre_compile(reg_str, 0, &pcreErrorStr, &pcreErrorOffset, NULL);

    if(reCompiled == NULL)
    {
#if LIST_DEBUG
        printf("ERROR: Could not compile '%s': %s\n", reg_str, pcreErrorStr);
#endif
        exit(1);
    }

/*
pcre_study() returns NULL for both errors and when it can not optimize the regex.  The last argument is how one checks for
errors (it is NULL if everything works, and points to an error string otherwise. 
*/
    pcreExtra = pcre_study(reCompiled, 0, &pcreErrorStr);

    if(pcreErrorStr != NULL) {
#if LIST_DEBUG
        printf("ERROR: Could not study '%s': %s\n", reg_str, pcreErrorStr);
#endif
        exit(1);
    }
    
    pcreExecRet = pcre_exec(reCompiled,
                            pcreExtra,
                            buf, 
                            strlen(buf),           // length of string
                            0,                      // Start looking at this point
                            0,                      // OPTIONS
                            subStrVec,
                            30);                    // Length of subStrVec
    if(pcreExecRet < 0)
    {
        pcre_free(reCompiled);
        pcre_free_study(pcreExtra);

        return 0;
    } 
    else
    {
#if LIST_DEBUG
        printf("Result: We have a match! ret: %d, start: %d, end: %d\n", pcreExecRet, subStrVec[0], subStrVec[1]);
#endif

        pcre_free(reCompiled);
        pcre_free_study(pcreExtra);
        return 1;
    }

	return 1;
}

int wildcard_cut(char *buf)
{
	return 0;
}

void shadowfog_add(char *buf, int start, int end)
{
	char pbuf[100] = {0x00};
	memcpy(pbuf, buf + start, end - start);
#if LIST_DEBUG
	printf("copy!\n");
	printf("line: %s\n", pbuf);
#endif
}

void to_next_line(char *buf, int *i)
{
	for (; buf[*i] != '\n'; (*i)++);
	(*i)++;
}

void list_usage()
{
    printf("Valid options are:\n");
    printf("-d, --dns <dns_ip>\n");
    printf("          DNS IP address for the GfwList Domains (Default: 127.0.0.1)\n");
    printf("-p, --port <dns_port>");
    printf("            DNS Port for the GfwList Domains (Default: 5353)\n");
    printf("-s, --ipset <ipset_name>\n");
    printf("            Ipset name for the GfwList domains\n");
    printf("            (If not given, ipset rules will not be generated.)\n");
    printf("-o, --output <FILE>\n");
    printf("            /path/to/output_filename\n");
    printf("-i, --insecure\n");
    printf("            Force bypass certificate validation (insecure)\n");
    printf("-l, --domain-list\n");
    printf("            Convert Gfwlist into domain list instead of dnsmasq rules\n");
    printf("           (If this option is set, DNS IP/Port & ipset are not needed)\n");
    printf("    --extra-domain-file\n");
    printf("            Include extra domains from a domain list text file\n");
    printf("            Please put one domain per line\n");
    printf("-h, --help\n");
}

	char line[1024]         = {0x00};
	char list_buf[BUF_SIZE] = {0x00};
	char temp_buf[BUF_SIZE] = {0x00};

int main(int argc, char *argv[])
{
	int  c;
	int  i   = 0;
	int  j   = 0;
	int  len = 0;
//    int  readbytes = 0;

    FILE *fp          = NULL;
//	char *end         = NULL;
	char *temp        = NULL;
//	char *start       = NULL;

	char *dns_ip      = NULL;
	char *list_url    = NULL;
	char *dns_port    = NULL;
	char *ipset_name  = NULL;
	char *output_file = NULL;
	char *domain_file = NULL;



	if (argc < 2)
	{
		list_usage();
		return -1;
	}

	/*
	 * option get
	 */
	int option_index = 0;
	static struct option long_options[] = {
		{ "extra-domain-file", required_argument, 0, 0 },
		{ "list-url",          required_argument, 0, 0 },
		{          0,          0,                 0, 0 }
	};

	opterr = 0;

	while ((c = getopt_long(argc, argv, "d:p:s:o:h:i",
				long_options, &option_index)) != -1)
	{
		switch (c)
		{
			case 0:
				if (option_index == 0)
				{
					domain_file = optarg;
				}
				else if (option_index == 1)
				{
					list_url = optarg;
				}
				else if (option_index == 2)
				{
					list_usage();
					exit(-1);
				}
				break;
			case 'd':
				dns_ip      = optarg;
				break;
			case 'p':
				dns_port    = optarg;
				break;
			case 's':
				ipset_name  = optarg;
				break;
			case 'o':
				output_file = optarg;
				break;
			case 'h':
				list_usage();
				break;
			case '?':
				printf("Unrecognized option: %s\n", optarg);
				list_usage();
				exit(-1);
		}
	}

    if (output_file == NULL || list_url == NULL)
    {
        printf("Need output file\n");
        list_usage();
		exit(EXIT_FAILURE);
    }

	if (opterr)
	{
		printf("opt err\n");
		list_usage();
		exit(EXIT_FAILURE);
	}

    if (dns_ip == NULL)
    {
        dns_ip = "8.8.8.8";
    }

    if (dns_port == NULL)
    {
        dns_port = "53";
    }

    if (ipset_name == NULL)
    {
        ipset_name = "gfwlist";
    }

/*
 * List Get
 */
/*
	i = shadowfog_curl_cmd("GET", list_url, NULL, NULL, NULL, 0, list_buf);
    if (i <= 0)
    {
        LOGI("[ss-list2dns] shadowfog_curl_cmd failed!");
        return -1;
    }

	end   = list_buf;
	start = list_buf;

	while ((*end) != 0)
	{
		for (; *end != '\n'; end++);

		*end = 0;

		end++;

		i = Base64decode(temp_buf + len, start);

		len += i;

		start = end;
	}
*/
    fp = fopen("/etc/shadowfog/dnslist.pac", "r");

    len = fread(temp_buf, sizeof(char), BUF_SIZE, fp);
    fclose(fp);

    char key[512];
    char key_str[65];
    char pac_sha256[65];

    printf("hash start\n");
    crypto_hash_sha256((unsigned char *)key, (unsigned char *)temp_buf, strlen(temp_buf));
    shadowfog_BIN_to_XX((unsigned char *)key, key_str, 32);
    key_str[64] = 0;

    fp = fopen("/etc/shadowfog/dnslist.pac.sha256", "r+");
    if (fp == NULL)
    {
        printf("fopen error:%s\n", strerror(errno));
    }

    fread(pac_sha256, sizeof(char), 64, fp);
    printf("[sf-list2dns] pac_sha256: %s\n", pac_sha256);
    pac_sha256[64] = 0;
    printf("[sf-list2dns] pac_sha256: %s\n", pac_sha256);

    printf("[sf-list2dns]key_str: %s\n", key_str);
    printf("[sf-list2dns] pac_sha256: %s\n", pac_sha256);
    fflush(stdout);


    if (strcmp("test", "test") == 0)
    {
        printf("eq\n");
    }
    if (strcmp(key_str, pac_sha256) == 0)
    {
        printf("not change\n");
        return 0;
    }

    printf("change\n");
    fseek(fp, 0, SEEK_SET);

    if (fwrite(key_str, sizeof(char), strlen(key_str), fp) <= 0)
    {
        printf("fwrite error!:%s\n", strerror(errno));
    }

    fclose(fp);
    printf("writed\n");

 
    printf("============set list_buf============\n");
    memset(list_buf, 0x00, sizeof(list_buf));

    printf("============temp_buf copy============\n");
    memcpy(temp_buf + len + 1, google_url, strlen(google_url));
    len += strlen(google_url);
    printf("============set blogspot_url copy============\n");

    memcpy(temp_buf + len, blogspot_url, strlen(blogspot_url));
    len += strlen(blogspot_url);
    temp_buf[len] = 0;

	i = 0;

    printf("============set list_buf============\n");
    memset(list_buf, 0x00, sizeof(list_buf));

	while (temp_buf[i] != 0)
	{
#if LIST_DEBUG
		printf("============start============\n");
#endif

		j = 0;
		memset(line, 0x00, sizeof(line));

		while(temp_buf[i] != '\n')
		{
			//printf("temp_buf[%d]: %d\n   line[%d] = %d\n\n", i, temp_buf[i], j, line[j]);

			line[j++] = temp_buf[i++];

			//printf("temp_buf[%d]: %c\n   line[%d] = %c\n\n\n\n", i - 1, temp_buf[i - 1], j - 1, line[j - 1]);
		}

		i++;

		line[j] = 0;
        if (line[0] != 0)
        {
#if LIST_DEBUG
            printf("line1: %s\n", line);
#endif
        }

#if LIST_DEBUG
        printf("is skip?\n");
#endif
		if (is_skip(line))
		{
#if LIST_DEBUG
            printf("skip\n");
#endif
			continue;
		}

		temp = head_cut(line);

		temp = tail_cut(temp);

		if (!is_url(temp))
		{
			continue;
		}

		wildcard_cut(line);

#if LIST_DEBUG
		printf("line2: %s\n", temp);
#endif

        sprintf(list_buf + strlen(list_buf), "server=/%s/%s#%s\nipset=/%s/%s\n", temp, dns_ip, dns_port, temp, ipset_name);
        
#if LIST_DEBUG
        printf("============Ending============\n");
#endif
	}

    printf("i: %ld\nlist_buf:%s\n", (long int)strlen(list_buf), list_buf);

    fp = fopen(output_file, "w+");
    if (fp == NULL)
    {
        printf("can't open file: %s\n", output_file);
        exit(0);
    }

    printf("fwrite start ...\n");
    fseek(fp, 0, SEEK_SET);
    fwrite(list_buf, 1, strlen(list_buf), fp);
    fclose(fp);

    printf("fwrite end ...\n");

	return 0;
}
