#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <errno.h>
#include <time.h>
#include <stdint.h>

#include <linux/kernel.h>
#include <stdio.h>
//#include <sys/sysinfo.h>

#include <netdb.h>
#include <errno.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <netinet/in.h>
#include <netinet/tcp.h>
#include <pthread.h>
#include <sys/un.h>
#include <sys/socket.h>
#include <pwd.h>

#include <sys/ioctl.h>
#include <net/if.h> 
#include <sys/wait.h>

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>

#include <curl/curl.h>


//#include "utils.h"
#include "shadowfog_log.h"
#include "shadowfog_utils.h"
#include "shadowfog_json.h"
#include "shadowfog_manager.h"
#include "shadowfog_base64.h"
#include "shadowfog_speed.h"
#include "shadowfog_fog_info.h"

//#include <sys/utsname.h>

static size_t
WriteMemoryCallback(void *contents,
                    size_t size,
                    size_t nmemb,
                    void *userp)
{
    size_t realsize = size * nmemb;
    struct MemoryStruct *mem = (struct MemoryStruct *)userp;

    mem->memory = realloc(mem->memory, mem->size + realsize + 1);
    if(mem->memory == NULL)
    {
        /* out of memory! */
        printf("not enough memory (realloc returned NULL)\n");
        return 0;
    }

    memcpy(&(mem->memory[mem->size]), contents, realsize);
    mem->size += realsize;
    mem->memory[mem->size] = 0;

    return realsize;
}

int shadowfog_ddns_query(shadowfog_ddns_req_t *req,
                    shadowfog_ddns_rsp_t *rsp)
{
    CURL *curl_handle;
    CURLcode res;
    curl_handle = curl_easy_init();
    rsp->memory = malloc(1);  /* will be grown as needed by the realloc above */
    rsp->size = 0;            /* no data at this point */

    curl_global_init(CURL_GLOBAL_ALL);
    curl_easy_setopt(curl_handle, CURLOPT_WRITEFUNCTION, WriteMemoryCallback);
    curl_easy_setopt(curl_handle, CURLOPT_WRITEDATA, (void *)rsp);
    curl_easy_setopt(curl_handle, CURLOPT_USERAGENT, req->conf->user_agent);
    /*curl_easy_setopt(curl_handle, CURLOPT_SSL_VERIFYPEER, 0L); CURLOPT_SSL_VERIFYHOST: on!*/
    curl_easy_setopt(curl_handle, CURLOPT_SSL_VERIFYHOST, 2L);

    curl_easy_setopt(curl_handle, CURLOPT_URL, req->api_url);
    if (strlen(req->query_str) > 0)
    {
        curl_easy_setopt(curl_handle, CURLOPT_POSTFIELDS, req->query_str);
    }

    res = curl_easy_perform(curl_handle);
    /*
    if(res != CURLE_OK)
    {
        fprintf(stderr, "curl_easy_perform() failed: %s\n",
                curl_easy_strerror(res));
    }
    else
    {
        printf("%lu bytes retrieved\n", (unsigned long)rsp->size);
        printf("%s\n", rsp->memory);
    }
    */

    curl_easy_cleanup(curl_handle);
    /* free(chunk.memory); Do not free here! Should release in application*/
    curl_global_cleanup();
    return res;
}
int shadowfog_ddns_init_conf(shadowfog_ddns_conf_t *conf)
{
        strncpy(conf->login_token, "12079,84f7755f2464126c6757dd10eac202e4", sizeof(conf->login_token));
        strncpy(conf->format, "json", sizeof(conf->format));
        strncpy(conf->domain, "supear.cn", sizeof(conf->domain));
        strncpy(conf->user_agent, "DDNS Client/1.0.0 (shadow.fog@yandex.ru)", sizeof(conf->user_agent));
	 return 0;
}

void get_external_ip(char * value)
{
    shadowfog_ddns_req_t req;
    shadowfog_ddns_rsp_t rsp;
    shadowfog_ddns_conf_t conf;
    req.conf = &conf;
    shadowfog_ddns_init_conf(req.conf);
    req.query_str[0] = '\0';

    /* fault tolerance */
    strncpy(req.api_url, "https://api.ipify.org?format=json", sizeof(req.api_url));
    shadowfog_ddns_query(&req, &rsp);

    if (rsp.size == 0)
    {
        strncpy(req.api_url, "http://ipinfo.io/json", sizeof(req.api_url));
        shadowfog_ddns_query(&req, &rsp);
    }
    if (rsp.size == 0)
    {
        strncpy(req.api_url, "http://myexternalip.com/json", sizeof(req.api_url));
        shadowfog_ddns_query(&req, &rsp);
    }
    //printf("[shadowfog]external ip is : %s\r\n",rsp.memory);
    shadowfog_json_get_string(rsp.memory, "ip", value);
    free(rsp.memory);

}



//   qnap :  PID  Uid     VmSize Stat Command
//   USER       PID %CPU %MEM    VSZ   RSS TTY 
void shadow_kill_process_by_name(char * processname)
{

    char cmd[512]={0x00};
    sprintf(cmd ,"ps aux | grep %s  | awk '{print $2}'  | xargs kill -9",processname);
    LOGI("[shadowfog] kill   cmd is   %s " , cmd);
    system(cmd);


    if(shadowfog_fog_info.hardware_platform == HARDWARE_PLATFORM_QNAP)
    {
	    sprintf(cmd ,"ps aux | grep %s  | awk '{print $1}'  | xargs kill -9",processname);
	    LOGI("[shadowfog] qnap kill   cmd is   %s " , cmd);
	    system(cmd);
    }

}


int is_directory(const char *path) 
{
   struct stat statbuf;
   if (stat(path, &statbuf) != 0)
       return 0;
   return S_ISDIR(statbuf.st_mode);
}
/*
man 2 stat:
if (stat(argv[1], &sb) == -1) {
   perror("stat");
   exit(EXIT_FAILURE);
}
*/


//  cat /proc/cpuinfo more details for openwrt

// If both of your server and client are deployed on Linux 3.7.1 or higher, you can turn on fast_open for lower latency.
//   Bit Flags for sysctl_tcp_fastopen 
//  #define TFO_CLIENT_ENABLE        1
//  #define TFO_SERVER_ENABLE       2
void shadowfog_enable_fastopen()
{
    char cmd[512]="echo 3 > /proc/sys/net/ipv4/tcp_fastopen";
    LOGI("[shadowfog] fastopen cmd is  %s " ,cmd);
    system(cmd);
}

